export default class Form {
    constructor(options: FormOptions);
    private _container;
    private _state;
    private _importedData;
    get: any;
    invoke: any;
    destroy(): void;
    importSchema(schema: Schema, data?: Data): Promise<any>;
    submit(): {
        data: Data;
        errors: Errors;
    };
    reset(): void;
    validate(): Errors;
    attachTo(parentNode: Element | string): void;
    detach(): void;
    _detach(emit?: boolean): void;
    setProperty(property: FormProperty, value: any): void;
    on(type: FormEvent, handler: Function): void;
    off(type: FormEvent, handler: Function): void;
    _createInjector(options: FormOptions, container: Element): any;
    _emit(type: any, data: any): void;
    _update(update: {
        add?: boolean;
        field: any;
        remove?: number;
        value?: any;
    }): void;
    _getState(): State;
    _setState(state: any): void;
}
export type Injector = any;
export type Data = {
    [x: string]: any;
};
export type Errors = {
    [x: string]: string[];
};
export type Modules = any[];
export type FormProperty = string;
export type FormEvent = string;
export type FormProperties = {
    [x: string]: any;
};
export type Schema = any;
export type FormOptions = {
    additionalModules?: Modules;
    container?: Element | string;
    injector?: any;
    modules?: Modules;
    properties?: FormProperties;
};
export type State = {
    data: Data;
    errors: Errors;
    properties: FormProperties;
    schema: Schema;
};
